
# EESREP
EESREP is a component based energy system optimisation python module.

EESREP allows setting-up an energy system using its API, parametrising its components, and optimize it using a time rolling horizon. The models generated by EESREP are based on the MILP format (see section Tutorials).

The following images an energy system example that can be done using EESREP.

<p align="center">
<img src="docs/images/system_example.png" alt="Energy system example" width="300"/>
</p>

EESREP is a research tool developed at CEA (DES/ISAS/DM2S/SERMA).

#   Install

EESREP can be installed using the command:

```
pip install eesrep
```

EESREP allows using several distinct MILP modeler module, none is installed with the module to let the user decide which one use. The built-in version of EESREP allows using the following modules:

- **mip** : Allows using the CBC solver installed with it. The CBC solver installation can however present some difficulties on linux or without the proper compiling tools (more information can be found at https://python-mip.readthedocs.io/en/latest/install.html);
- **docplex** : Official CPLEX modeling module (solver only free for students or with a maximum of 1000 variables and constraints, see https://pypi.org/project/docplex/);
- **pyomo** : Interfaces with several solvers that have to be installed aside of it (see installation instructions at https://pyomo.readthedocs.io/en/stable/installation.html).

#   Tutorials

Several jupyter notebook are present in the folder tutorials to explain how to build a energy system MILP model, and how to use EESREP. They are sorted in different categories:

-   **MILP_i** : explains how a MILP works and and how to set-up one;
-   **Use_i** : Explains how to use the module EESREP;
-   **Dev_i** : Explains how to create and use a custom component with EESREP.

More example can be found in the EESREP test base (folder tests/tests_theory).

#   Documentation

The Sphinx generated documentation of the module can be found at this adress:

https://readthedocs.org/projects/eesrep/